//go:build !disable_pgv
// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: contrib/envoy/extensions/private_key_providers/cryptomb/v3alpha/cryptomb.proto

package v3alpha

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on CryptoMbPrivateKeyMethodConfig with the
// rules defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *CryptoMbPrivateKeyMethodConfig) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on CryptoMbPrivateKeyMethodConfig with
// the rules defined in the proto definition for this message. If any rules
// are violated, the result is a list of violation errors wrapped in
// CryptoMbPrivateKeyMethodConfigMultiError, or nil if none found.
func (m *CryptoMbPrivateKeyMethodConfig) ValidateAll() error {
	return m.validate(true)
}

func (m *CryptoMbPrivateKeyMethodConfig) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if all {
		switch v := interface{}(m.GetPrivateKey()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, CryptoMbPrivateKeyMethodConfigValidationError{
					field:  "PrivateKey",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, CryptoMbPrivateKeyMethodConfigValidationError{
					field:  "PrivateKey",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetPrivateKey()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return CryptoMbPrivateKeyMethodConfigValidationError{
				field:  "PrivateKey",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if m.GetPollDelay() == nil {
		err := CryptoMbPrivateKeyMethodConfigValidationError{
			field:  "PollDelay",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if d := m.GetPollDelay(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			err = CryptoMbPrivateKeyMethodConfigValidationError{
				field:  "PollDelay",
				reason: "value is not a valid duration",
				cause:  err,
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		} else {

			gte := time.Duration(0*time.Second + 1000000*time.Nanosecond)

			if dur < gte {
				err := CryptoMbPrivateKeyMethodConfigValidationError{
					field:  "PollDelay",
					reason: "value must be greater than or equal to 1ms",
				}
				if !all {
					return err
				}
				errors = append(errors, err)
			}

		}
	}

	if len(errors) > 0 {
		return CryptoMbPrivateKeyMethodConfigMultiError(errors)
	}

	return nil
}

// CryptoMbPrivateKeyMethodConfigMultiError is an error wrapping multiple
// validation errors returned by CryptoMbPrivateKeyMethodConfig.ValidateAll()
// if the designated constraints aren't met.
type CryptoMbPrivateKeyMethodConfigMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m CryptoMbPrivateKeyMethodConfigMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m CryptoMbPrivateKeyMethodConfigMultiError) AllErrors() []error { return m }

// CryptoMbPrivateKeyMethodConfigValidationError is the validation error
// returned by CryptoMbPrivateKeyMethodConfig.Validate if the designated
// constraints aren't met.
type CryptoMbPrivateKeyMethodConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e CryptoMbPrivateKeyMethodConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e CryptoMbPrivateKeyMethodConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e CryptoMbPrivateKeyMethodConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e CryptoMbPrivateKeyMethodConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e CryptoMbPrivateKeyMethodConfigValidationError) ErrorName() string {
	return "CryptoMbPrivateKeyMethodConfigValidationError"
}

// Error satisfies the builtin error interface
func (e CryptoMbPrivateKeyMethodConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sCryptoMbPrivateKeyMethodConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = CryptoMbPrivateKeyMethodConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = CryptoMbPrivateKeyMethodConfigValidationError{}
